d("myAccountInfoView",['ccrz', 'util'], function(CCRZ, UTIL) {
    return {
        extendMyAccountInfoView: function() {
            let isRefresh = false;
            CCRZ.pubSub.on("view:contactInfoView:refresh", function(view) {
                if(!isRefresh){
                    view.events['click .openEditModal'] = 'handleEditModal';
                    view.events['click .createLead'] = 'handleCreateChangeRequest';
                    view.renderPhone = function() {
                        var v = this;
                        v.$el.html(v.templatePhone(v.model.toJSON()));
                        UTIL.hideLoader();
                    };
                    view.renderDesktop = function() {
                        var v = this;
                        v.$el.html(v.templateDesktop(CCRZ.myaccountModel.toJSON()));
                        UTIL.hideLoader();
                    };
                    view.handleEditModal = function(event){
                        $('#accountInfoModal').modal({backdrop: true, show: true}); 
                        $('#accountInfoModal').removeClass('fade');
                        $('.modal-backdrop').removeClass('fade');
                        $('.createLead').prop('disabled', false);
                    };
                    view.handleCreateChangeRequest = function(event){
                        if(($('.acc_subject').val()).trim() != '' && ($('.acc_description').val()).trim() != ''){
                            UTIL.showLoader();
                            let reqData = {
                                'type' : 'update',
                                'subject' : $('.acc_subject').val(),
                                'description' : $('.acc_description').val()
                            };
                            CCRZ.remoteModel.createLead(JSON.stringify(reqData), function(res, evt){
                                if(res && res.success && res.data){
                                    $('.createLead').prop('disabled', true);
                                    CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('INFO', "messagingSection-accModal-Info", CCRZ.processPageLabelMap('KFB2B_myAccount_successRequest').toString()));
                                    setTimeout(function(){
                                        $('.messagingSection-accModal-Info').css('display', 'none');
                                        $('.acc_subject').val('');
                                        $('.acc_description').val('');
                                        $('.close').click();
                                    }, 3000);
                                } else {
                                    // Error Handling
                                    $('.createLead').prop('disabled', false);
                                    CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "messagingSection-accModal-Error", CCRZ.processPageLabelMap('KFB2B_myAccount_errorRequest').toString()));
                                    setTimeout(function(){
                                        $('.messagingSection-accModal-Error').css('display', 'none');
                                    }, 3000);
                                }
                                UTIL.hideLoader();
                            });
                        } else {
                            CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "messagingSection-accModal-Error", CCRZ.processPageLabelMap('KFB2B_myAccount_allFieldsRequired').toString()));
                            setTimeout(function(){
                                $('.messagingSection-accModal-Error').css('display', 'none');
                            }, 3000);
                        }
                    };
                    view.delegateEvents();
                    view.render();
                    isRefresh = true;
                }
            });
        }
    }
});