d("myAccountCPView",['ccrz', 'util'], function(CCRZ, UTIL) {
    return {
        extendMyAccountCPView: function() {
            CCRZ.pubSub.once("view:changePasswordView:refresh", function(cpView) {
                cpView.events['blur #current_password'] = 'handleOldPassword';
                cpView.events['blur #new_password'] = 'handleNewPassword';
                cpView.events['blur #new_password_verify'] = 'handleConfirmPassword';
                cpView.events['input #new_password'] = 'handleInputPassword';
                cpView.events['input #new_password_verify'] = 'handleInputPassword';
                cpView.events['input #current_password'] = 'handleInputPassword';
                // Init Values
                cpView.model.set('isOldPassword', false);
                cpView.model.set('isNewPassword', false);
                cpView.model.set('isConfirmPassword', false);
                cpView.model.set('isMatch', false);
                // Old Password Validation
                cpView.handleOldPassword = function(){
                    let value = event.target.value, isValid = false, _this = this;
                    if(value == ''){
                        _this.updateError(true, CCRZ.processPageLabelMap('KFB2B_myAccount_oldPasswordReq').toString());
                    } else {
                        if (UTIL.validate(event.target) == false) {
                            _this.updateError(true, CCRZ.processPageLabelMap('KFB2B_myAccount_oldPasswordCriteria').toString());
                        } else {
                            isValid = true;
                        }
                    }
                    _this.model.set('isOldPassword', isValid);
                    if(isValid){
                        _this.updateError(false, '');
                    }
                };
                // New Password Validation
                cpView.handleNewPassword = function(){
                    let value = event.target.value, isValid = false, _this = this;
                    if(value == ''){
                        _this.updateError(true, CCRZ.processPageLabelMap('KFB2B_myAccount_newPasswordReq').toString());
                    } else {
                        if (UTIL.validate(event.target) == false) {
                            _this.updateError(true, CCRZ.processPageLabelMap('KFB2B_myAccount_newPasswordCriteria').toString());
                        } else {
                            isValid = true;
                        }
                    }
                    _this.model.set('isNewPassword', isValid);
                    if(isValid && !_this.checkPasswordEqual()){
                        _this.updateError(true, CCRZ.processPageLabelMap('KFB2B_all_passwordMatchError').toString());
                    } else {
                        if(isValid){
                            _this.updateError(false, '');
                        }
                    }
                    
                };
                // Confirm Password Validation
                cpView.handleConfirmPassword = function(){
                    let value = event.target.value, isValid = false, _this = this;
                    if(value == ''){
                        _this.updateError(true, CCRZ.processPageLabelMap('KFB2B_myAccount_confirmPasswordReq').toString());
                    } else {
                        if (UTIL.validate(event.target) == false) {
                            _this.updateError(true, CCRZ.processPageLabelMap('KFB2B_myAccount_confirmPasswordCriteria').toString());
                        } else {
                            isValid = true;
                        }
                    }
                    _this.model.set('isConfirmPassword', isValid);
                    if(isValid && !_this.checkPasswordEqual()){
                        _this.updateError(true, CCRZ.processPageLabelMap('KFB2B_all_passwordMatchError').toString());
                    } else {
                        if(isValid){
                            _this.updateError(false, '');
                        }
                    }
                };
                cpView.checkPasswordEqual = function(){
                    return $('#new_password').val() === $('#new_password_verify').val();
                };
                cpView.validateFields = function(){
                    let _this = this;
                    return _this.model.get('isOldPassword') && _this.model.get('isNewPassword') && _this.model.get('isConfirmPassword') && _this.model.get('isMatch');
                };
                cpView.handleInputPassword = function(){
                    let _this = this;
                    _this.model.set('isMatch', _this.checkPasswordEqual());
                    _this.validateBtn();
                }
                cpView.updateError = function(isShow, message){
                    if(isShow){
                        $('.messagingSection-CP-Error .alert').html(message);
                        $('.messagingSection-CP-Error').css('display', 'block');
                    } else {
                        $('.messagingSection-CP-Error').css('display', 'none');
                    }
                }
                cpView.validateBtn = function(){
                    let _this = this;
                    if(_this.validateFields()){
                        $('.updatepassword').prop('disabled', false);
                        _this.updateError(false, '');
                    } else {
                        $('.updatepassword').prop('disabled', true);
                    }
                };
                cpView.delegateEvents();
            });
        }
    }
});