d("myAccountCartView",['ccrz', 'util'], function(CCRZ, UTIL) {
    return {
        extendAccountCartView: function() {
            let isRefresh = false;
            CCRZ.pubSub.on("view:myCartsView:refresh", function(cartView) {
                if(!isRefresh){
                    cartView.events['click .deleteCart'] = 'handleRemoveCart';
                    cartView.events['click .openModal'] = 'handleOpenModel';
                    cartView.handleRemoveCart = function(event){
                        UTIL.showLoader();
                        let id = event.currentTarget.dataset.id, v = this;
                        this.cartList.deleteCart(id, function(response){
                            if(response && response.success){
                                CCRZ.pagevars.currentCartID = '';
                            }
                            CCRZ.headerView.update();
                            v.cartList.refresh(function() { v.render();});
                        });
                    };
                    cartView.handleOpenModel = function(event){
                        let id = event.currentTarget.dataset.id;
                        $('#renameMod_' + id).modal({backdrop: true, show: true}); 
                        $('#renameMod_' + id).removeClass('fade');
                        $('.modal-backdrop').removeClass('fade');
                    };
                    cartView.renameCart = function(event) {
                        UTIL.showLoader();
                        this.cartListRenameCart(event);
                    };
                    cartView.renameCartOnEnter = function(event){
                        let code = event.which;
                        if(code===13) {
                         event.preventDefault();
                         UTIL.showLoader();
                         this.cartListRenameCart(event);
                        }
                    };
                    cartView.renderDesktop = function(){
                        let v = this;
                        this.cartList.fetch(function (response){
                         v.$el.html(v.templateDesktop(v.cartList.toJSON()));
                         UTIL.hideLoader();
                        });
                    };
                    cartView.delegateEvents();
                    isRefresh = true;
                    cartView.render();
                }
            });
        }
    }
});